# Test cases for Homework 7 - Fall 2023
#-------------------------------------------------------------------------------------------
import autotester_base
from autotester_base import Lit, opts

def testall(start=None, mode='brief', clear=True):
   autotester_base.test_target_list(_target_list, _test_cases, start, mode, clear)

def test(fun_or_name, cases=None, mode=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, mode, alias, input, _test_cases)

def vtest(fun_or_name, cases=None, alias=None, input=None):
   autotester_base.test_single_function(fun_or_name, cases, 'verbose', alias, input, _test_cases)

#-------------------------------------------------------------------------------------------

_target_list = [
   # from Lab 7:
   'charType',
   'firstVowelPosition',
   'translateWord',
   'translateLine',
   'translateFile',
   'spell',
   # opts('translateFile', cases=1),
   # opts('spell', mode='verbose'),
   # additional exercises:
   'congress',
   'allEven',
   'isValid',
   # EXTRA CREDIT:
   'translateWord2', # capitalization/punctuation version
   'formatComplex',
   'monthName',
   'weekdayNum',
   'calendar',
   ]

#-------------------------------------------------------------------------------------------

_test_cases = {

   'charType':{
      1: ('', ('a',), 'vowel'),
      2: ('', ('E',), 'vowel'),
      3: ('', ('b',), 'consonant'),
      4: ('', ('y',), 'consonant'),
      5: ('', ('Z',), 'consonant'),
      6: ('', ('?',), 'punctuation mark'),
      7: ('', ('!',), 'punctuation mark'),
      8: ('', (',',), 'punctuation mark'),
      9: ('', ('3',), 'digit'),
      10: ('', ('0',), 'digit'),
      },
   'firstVowel':{
      1: ('', ('crystalline',), 'a'),
      2: ('', ('apple',), 'a'),
      3: ('', ('pineapple',), 'i'),
      4: ('', ('syrup',), 'u'),
      5: ('', ('rhythm',), ''),
      6: ('', ('z',), ''),
      },
   'firstVowelPosition':{
      1: ('', ('crystalline',), 5),
      2: ('', ('apple',), 0),
      3: ('', ('pineapple',), 1),
      4: ('', ('syrup',), 3),
      5: ('', ('rhythm',), -1),
      6: ('', ('z',), -1),
      7: ('', ('heh',), 1),
      },
   'translateWord':{
      1: ('', ('scram',), 'amscray'),
      2: ('', ('apple',), 'appleway'),
      3: ('', ('rhythm',), 'rhythmay'),
      4: ('', ('pancakes',), 'ancakespay'),
      5: ('', ('i',), 'iway'),
      6: ('', ('with',), 'ithway'),
      7: ('', ('house',), 'ousehay'),
      8: ('', ('supposed',), 'upposedsay'),
      9: ('', ('pig',), 'igpay'),
   },
   'translateWord2':{
      1: ('', ('Spain',), 'Ainspay'),
      2: ('', ('Applesauce',), 'Applesauceway'),
      3: ('', ('hello?',), 'ellohay?'),
      4: ('', ('Scram!',), 'Amscray!'),
      5: ('', ('No',), 'Onay'),
      6: ('', ('reality;',), 'ealityray;'),
      7: ('', ('supposed,',), 'upposedsay,'),
      8: ('', ('dream.',), 'eamdray.'),
      9: ('', ('Hill',), 'Illhay'),
      10: ('', ('House,',), 'Ousehay,'),
      11: ('', ('Within,',), 'Ithinway,'),
      12: ('', ('upright,',), 'uprightway,'),
      13: ('', ('rhythm!',), 'rhythmay!'),
      14: ('', ('Rhythm',), 'Rhythmay'),
      15: ('', ('Rhythm;',), 'Rhythmay;'),
      16: ('', ('Syrup.',), 'Upsyray.'),
   },
   'translateLine':{
      1: ('', ('scram',), 'amscray'),
      2: ('', ('got it',), 'otgay itway'),
      3: ('', ('the rain in spain',), 'ethay ainray inway ainspay'),
      4: ('', ('i scram with apple pancakes',), 'iway amscray ithway appleway ancakespay'),
      5: ('', ('',), ''),
      6: ('', ('hill house stood by itself against its hills holding darkness within',),
          'illhay ousehay oodstay byay itselfway againstway itsway illshay oldinghay arknessday ithinway'),
      },
   'translateFile':{
      1: ('', ('haunting.txt',), None,
          'onay', 'ivelay', 'organismway', 'ancay', 'ontinuecay', 'orfay', 'onglay', 'otay',
          'existway', 'anelysay', 'underway', 'onditionscay', 'ofway', 'absoluteway', ('eality;ray', 'ealityray;'),
          'evenway', 'arkslay', 'andway', 'atydidskay', 'areway', ('upposed,say', 'upposedsay,'), 'byay',
          ('ome,say', 'omesay,'), 'otay', ('eam.dray', 'eamdray.'), 'illhay', ('ouse,hay', 'Ousehay,'),
          'otnay', ('ane,say', 'anesay,'), 'oodstay', 'byay', 'itselfway', 'againstway', 'itsway',
          ('ills,hay', 'illshay,'), 'oldinghay', 'arknessday', ('ithin;way', 'ithinway;'), 'itway', 'adhay',
          'oodstay', 'osay', 'orfay', 'eightyway', 'earsyay', 'andway', 'ightmay', 'andstay', 'orfay',
          'eightyway', ('ore.may', 'oremay.'), ('ithin,way', 'Ithinway,'), 'allsway', 'ontinuedcay',
          ('upright,way', 'uprightway,'), 'icksbray', 'etmay', ('eatly,nay', 'eatlynay,'), 'oorsflay',
          'ereway', ('irm,fay', 'irmfay,'), 'andway', 'oorsday', 'ereway', 'ensiblysay', ('ut;shay', 'utshay;'),
          'ilencesay', 'aylay', 'eadilystay', 'againstway', 'ethay', 'oodway', 'andway',
          'onestay', 'ofway', 'illhay', ('ouse,hay', 'ousehay,'), 'andway', 'ateverwhay',
          'alkedway', ('ere,thay', 'erethay,'), 'alkedway', ('alone.way', 'aloneway.')),
      # correct punctuation and capitalization
      # 2: ('', ('haunting.txt',), None,
      #     Lit('Onay ivelay organismway ancay ontinuecay orfay onglay otay existway'),
      #     Lit('anelysay underway onditionscay ofway absoluteway ealityray; evenway'),
      #     Lit('arkslay andway atydidskay areway upposedsay, byay omesay, otay'),
      #     Lit('eamdray. Illhay Ousehay, otnay anesay, oodstay byay itselfway'),
      #     Lit('againstway itsway illshay, oldinghay arknessday ithinway; itway adhay'),
      #     Lit('oodstay osay orfay eightyway earsyay andway ightmay andstay orfay'),
      #     Lit('eightyway oremay. Ithinway, allsway ontinuedcay uprightway,'),
      #     Lit('icksbray etmay eatlynay, oorsflay ereway irmfay, andway oorsday'),
      #     Lit('ereway ensiblysay utshay; ilencesay aylay eadilystay againstway'),
      #     Lit('ethay oodway andway onestay ofway Illhay Ousehay, andway ateverwhay'),
      #     Lit('alkedway erethay, alkedway aloneway.')),
      },
   'spell':{
      1: ('haunting2.txt', (), None,
          Lit('wals unrecognized'),
          Lit('agianst unrecognized'),
          Lit('Howse unrecognized'),
          Lit('wallked unrecognized')),
      2: ('haunting3.txt', (), None,
          Lit('realitie unrecognized'),
          Lit('suppozed unrecognized'),
          Lit('Withhin unrecognized'),
          Lit('briks unrecognized'),
          Lit('phloors unrecognized'),
          Lit('doorz unrecognized')),
      },
   'congress':{
      1: ('37\n37', (), None, ('Senate or the House', 'Senate or House')),
      2: ('27\n10', (), None, Lit('You could run for the House')),
      3: ('30\n5', (), None, 'stay out of politics'),
      4: ('30\n9', (), None, ('Senate or the House', 'Senate or House')),
      5: ('25\n7', (), None, Lit('You could run for the House')),
      6: ('25\n6', (), None, 'stay out of politics'),
   },
   'allEven':{
      1: ('', ([6, 10, 20, 8, 12, 10],), True),
      2: ('', ([6, 10, 20, 8, 12, 11],), False),
      3: ('', ([10, 14, 3],), False),
      4: ('', ([1, 2, 3, 4, 13, 12, 10],), False),
      5: ('', ([10],), True),
      6: ('', ([9],), False),
      7: ('', ([1, 2, 4, 6, 8, 10, 12, 14],), False),
   },
   'isValid':{
      1: ('', (2, 29, 2016), True),
      2: ('', (2, 29, 2018), False),
      3: ('', (2, 29, 1900), False),
      4: ('', (2, 29, 1600), True),
      5: ('', (1, 0, 2016), False),
      6: ('', (1, 30, 2016), True),
      7: ('', (2, 30, 2016), False),
      8: ('', (1, 30, -1900), False),
      9: ('', (13, 28, 2016), False),
      10: ('', (4, 31, 2002), False),
      11: ('', (12, 28, 1900), True),
      12: ('', (10, 5, 2016), True),
      13: ('', (10, 0, 2016), False),
      14: ('', (1, 1, 0), False),
      15: ('', (1, 1, 1), True),
      16: ('', (12, 32, 2000), False),
      17: ('', (11, 31, 2000), False),
      18: ('', (0, 15, 2016), False),
      19: ('', (7, 7, 1054), True),
      20: ('', (6, 31, 1776), False),
      },
   'formatComplex':{
      1: ('', (0, 0), '0'),
      2: ('', (3, 0), '3'),
      3: ('', (-5, 0), '-5'),
      4: ('', (0, 1), 'i'),
      5: ('', (0, -1), '-i'),
      6: ('', (0, 3), '3i'),
      7: ('', (0, -5), '-5i'),
      8: ('', (3, 2), '3+2i'),
      9: ('', (3, -2), '3-2i'),
      10: ('', (-2, 1), '-2+i'),
      11: ('', (-15, 20), '-15+20i'),
      12: ('', (1, -1), '1-i'),
      13: ('', (-1, -1), '-1-i'),
      14: ('', (1, 1), '1+i'),
      15: ('', (-1, 1), '-1+i'),
   },
   'monthName':{
      1: ('', (1,), 'January'),
      2: ('', (2,), 'February'),
      3: ('', (3,), 'March'),
      4: ('', (4,), 'April'),
      5: ('', (5,), 'May'),
      6: ('', (6,), 'June'),
      7: ('', (7,), 'July'),
      8: ('', (8,), 'August'),
      9: ('', (9,), 'September'),
      10: ('', (10,), 'October'),
      11: ('', (11,), 'November'),
      12: ('', (12,), 'December'),
   },
   'weekdayNum':{
      1: ('', (1, 1, 1900), 1),
      2: ('', (1, 7, 1900), 0),
      3: ('', (10, 21, 2009), 3),
      4: ('', (2, 25, 2012), 6),
      5: ('', (10, 29, 2013), 2),
      6: ('', (7, 4, 2176), 4),
      7: ('', (3, 1, 1968), 5),
      8: ('', (3, 1, 1974), 5),
   },
   'calendar':{
      1: ('', (10, 2009), None,
          Lit('October 2009'),
          Lit('Su Mo Tu We Th Fr Sa'),
          Lit('             1  2  3'),
          Lit(' 4  5  6  7  8  9 10'),
          Lit('11 12 13 14 15 16 17'),
          Lit('18 19 20 21 22 23 24'),
          Lit('25 26 27 28 29 30 31')),
      2: ('', (2, 2012), None,
          Lit('February 2012'),
          Lit('Su Mo Tu We Th Fr Sa'),
          Lit('          1  2  3  4'),
          Lit(' 5  6  7  8  9 10 11'),
          Lit('12 13 14 15 16 17 18'),
          Lit('19 20 21 22 23 24 25'),
          Lit('26 27 28 29')),
      3: ('', (10, 2016), None,
          Lit('October 2016'),
          Lit('Su Mo Tu We Th Fr Sa'),
          Lit('                   1'),
          Lit(' 2  3  4  5  6  7  8'),
          Lit(' 9 10 11 12 13 14 15'),
          Lit('16 17 18 19 20 21 22'),
          Lit('23 24 25 26 27 28 29'),
          Lit('30 31')),
      4: ('', (1, 1900), None,
          Lit('January 1900'),
          Lit('Su Mo Tu We Th Fr Sa'),
          Lit('    1  2  3  4  5  6'),
          Lit(' 7  8  9 10 11 12 13'),
          Lit('14 15 16 17 18 19 20'),
          Lit('21 22 23 24 25 26 27'),
          Lit('28 29 30 31')),
      5: ('', (2, 2004), None,
          Lit('February 2004'),
          Lit('Su Mo Tu We Th Fr Sa'),
          Lit(' 1  2  3  4  5  6  7'),
          Lit(' 8  9 10 11 12 13 14'),
          Lit('15 16 17 18 19 20 21'),
          Lit('22 23 24 25 26 27 28'),
          Lit('29')),
      6: ('', (9, 3001), None,
          Lit('September 3001'),
          Lit('Su Mo Tu We Th Fr Sa'),
          Lit('       1  2  3  4  5'),
          Lit(' 6  7  8  9 10 11 12'),
          Lit('13 14 15 16 17 18 19'),
          Lit('20 21 22 23 24 25 26'),
          Lit('27 28 29 30')),
      7: ('', (8, 2019), None,
          Lit('August 2019'),
          Lit('Su Mo Tu We Th Fr Sa'),
          Lit('             1  2  3'),
          Lit(' 4  5  6  7  8  9 10'),
          Lit('11 12 13 14 15 16 17'),
          Lit('18 19 20 21 22 23 24'),
          Lit('25 26 27 28 29 30 31')),
      8: ('', (2, 2021), None,
          Lit('February 2021'),
          Lit('Su Mo Tu We Th Fr Sa'),
          Lit('    1  2  3  4  5  6'),
          Lit(' 7  8  9 10 11 12 13'),
          Lit('14 15 16 17 18 19 20'),
          Lit('21 22 23 24 25 26 27'),
          Lit('28')),
      9: ('', (10, 2023), None,
          Lit('October 2023'),
          Lit('Su Mo Tu We Th Fr Sa'),
          Lit(' 1  2  3  4  5  6  7'),
          Lit(' 8  9 10 11 12 13 14'),
          Lit('15 16 17 18 19 20 21'),
          Lit('22 23 24 25 26 27 28'),
          Lit('29 30 31')),
      10: ('', (11, 2023), None,
           Lit('November 2023'),
           Lit('Su Mo Tu We Th Fr Sa'),
           Lit('          1  2  3  4'),
           Lit(' 5  6  7  8  9 10 11'),
           Lit('12 13 14 15 16 17 18'),
           Lit('19 20 21 22 23 24 25'),
           Lit('26 27 28 29 30')),
      },

}
